#include <PSX/File/Processor/cd_file_processor.hpp>
#include <PSX/AutoLBA/auto_lba_declaration.hpp>
#include <PSX/GPU/gpu.hpp>
#include <stdio.h>

enum LBA {
    __jabyengine_start_lba_request
    __jabyengine_request_lba_for(FONT, "ASSETS/FONT.BIN"),
    __jabyengine_end_lba_request
};

static void load_assets() {
    static const JabyEngine::CDFile Assets[] = {
        JabyEngine::CDFileBuilder::simple_tim(LBA::FONT, JabyEngine::SimpleTIM(320, 0, 320, 256)),
    };

    const auto                  buffer_cfg = JabyEngine::CDFileProcessor::BufferConfiguration::new_default();
    JabyEngine::CDFileProcessor file_processor;

    file_processor.setup(lba, Assets, buffer_cfg);
    while(true) {
        switch(file_processor.process()) {
            case JabyEngine::Progress::InProgress:
                break;

            case JabyEngine::Progress::Done:
                if(!file_processor.next(lba, buffer_cfg)) {
                    return;
                }
                break;
            
            case JabyEngine::Progress::Error:
                printf("Error detected! Aborting load\n");
                return;
        }
    }
}

void main() {
    printf("Hello PoolBox!\n");
    load_assets();

    while(true) {
        JabyEngine::GPU::swap_buffers_vsync(2);
    }
}
__declare_lba_header(LBA);